#!/usr/bin/php -q
<?php


/*
	cfg
*/
// Wait this many seconds between loops
$sleep = 5;
$app_dir = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR) . DIRECTORY_SEPARATOR;

error_reporting(E_ALL);
require_once "System/Daemon.php";

require_once($app_dir . 'config.php');
require_once($app_dir . 'functions.php');

// Make sure MYSQL says run
if (!($db = dbc())) die("No MySQL.");

$result = dbq($db, "SELECT `value` FROM `daemon` WHERE `param` = 'run' LIMIT 1");
if ($result->num_rows != 1) die("MYSQL run parameter is not set.");

$arr = $result->fetch_array();

if ($arr[0] != 1) die("MYSQL run parameter is not 1\n");

$db->close();

// Daemon Config
System_Daemon::setOption("appName", "busmap");
System_Daemon::setOption("appDescription", "RU Bus Map");
System_Daemon::setOption("authorName", "Anton Saruknanov");
System_Daemon::setOption("authorEmail", "anton@ant.sr");

	
// Launch Daemon
System_Daemon::start();
System_Daemon::log(System_Daemon::LOG_INFO, "".System_Daemon::getOption("appName")." daemon spawned.");

$error = false;
while ($error == false) {	
	$warning = "";
	
	// do things
	include($app_dir.'cron/getRouteConfig.php');
	include($app_dir.'cron/getPredictions.php');
	include($app_dir.'cron/getVehicleLocations.php');
	
	// log any non-fatals ($warning)
	if ($warning != "") System_Daemon::log(System_Daemon::LOG_ERR, "warn: " . $warning);
	
	// sleep
	System_Daemon::iterate($sleep);
	
}

System_Daemon::log(System_Daemon::LOG_ERR, "STOPPED: " . $error);
System_Daemon::log(System_Daemon::LOG_ERR, System_Daemon::getOption("appName")." daemon stopped!");
System_Daemon::stop();
?>